///////////////////////////////////////////////////////////////////////
// USB8VI4DI0RDlg.cpp : implementation file
// Author : Philip Allen
// Version :1   Date   : 2  September 2007 Initial Version
// Version :2   Date   : 16 November  2007 Changes to match new Module Interface
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ModuleInterface.h"
#include "CommPortSelect.h"
#include "serialport.h"
#include "USB8VI4DI0R.h"
#include "USB8VI4DI0RDlg.h"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Serial port instance

	CSerialPort *port = new CSerialPort();
	CModuleInterface *ControlInterface = new CModuleInterface(port);

/////////////////////////////////////////////////////////////////////////////
// Select port Dialog instance
	CCommPortSelect selectdlg ;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSB8VI4DI0RDlg dialog

CUSB8VI4DI0RDlg::CUSB8VI4DI0RDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSB8VI4DI0RDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSB8VI4DI0RDlg)
	m_txtIntVal = 0;
	m_Port_Interval = 0;
	m_Port_Number = 0;
	m_Relay_Num = 0;
	m_txtCommPort = 0;
	m_DataPortSelected = _T("");
	m_Port_Reading = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSB8VI4DI0RDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSB8VI4DI0RDlg)
	DDX_Control(pDX, IDC_RECYCLE_OFF, mRelayRecycleOff);
	DDX_Control(pDX, IDC_RECYCLE_ON, mRelayRecycleOn);
	DDX_Control(pDX, IDC_START, mRelayCycStart);
	DDX_Control(pDX, IDC_OPEN, mRelayOpen);
	DDX_Control(pDX, IDC_CLOSE, mRelayClose);
	DDX_Control(pDX, IDC_CLEAR, mRelayClear);
	DDX_Control(pDX, IDC_PORT_SCAN_BUTTON, mSelectPortScan);
	DDX_Control(pDX, IDC_RELAY_STATE_TXT, m_txtRelayCycle);
	DDX_Control(pDX, IDC_SINGLE_REL_NUM, m_edRelayNum);
	DDX_Control(pDX, IDC_PORT_INT_SCROLLBAR, m_vsbPortInterval);
	DDX_Control(pDX, IDC_REL_INT_SCROLLBAR, m_vsbCycleInterval);
	DDX_Text(pDX, IDC_INT_VAL, m_txtIntVal);
	DDX_Text(pDX, IDC_PORT_INT_VAL, m_Port_Interval);
	DDX_Text(pDX, IDC_RELAY_NUM, m_Relay_Num);
	DDX_Text(pDX, IDC_COM_PORT_NUM, m_txtCommPort);
	DDX_Text(pDX, IDC_DATA_PORT_NUM, m_DataPortSelected);
	DDV_MaxChars(pDX, m_DataPortSelected, 1);
	DDX_Text(pDX, IDC_PORT_VAL, m_Port_Reading);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSB8VI4DI0RDlg, CDialog)
	//{{AFX_MSG_MAP(CUSB8VI4DI0RDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RECYCLE_ON, OnRecycleOn)
	ON_BN_CLICKED(IDC_RECYCLE_OFF, OnRecycleOff)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_COMMAND(ID_COMMPORT_PORT1, OnCommportPort1)
	ON_COMMAND(ID_COMMPORT_PORT2, OnCommportPort2)
	ON_COMMAND(ID_COMMPORT_PORT3, OnCommportPort3)
	ON_COMMAND(ID_COMMPORT_PORT4, OnCommportPort4)
	ON_COMMAND(ID_COMMPORT_SELECTPORT, OnCommportSelectport)
	ON_COMMAND(ID_DATAPORT_PORTB, OnDataportPortb)
	ON_COMMAND(ID_DATAPORT_PORTC, OnDataportPortc)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_WM_TIMER()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_PORT_SCAN_BUTTON, OnPortScanButton)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP_DEVICEMANAGER, OnHelpDevicemanager)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSB8VI4DI0RDlg message handlers

BOOL CUSB8VI4DI0RDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	////////////////////////////////////////////////////////////////////
	// Load Menues
	// Set pointers to Com port sub menu items 
	m_mainMenu = GetMenu();
	m_pmnuPort = m_mainMenu->GetSubMenu(1);
	m_pmnuData = m_mainMenu->GetSubMenu(2);

	////////////////////////////////////////////////////////////////////
    // Set up com port
    if (SetUpComPort())
	{
		//  Setup Control status
		SetUpControls();
		EnableControls();
		Initialise();
		ControlInterface->ClearRelays(GIMAXRELAY);
	    mbRecycleOn = false;
		m_DataPortSelected = "B";	
		UpdateData(FALSE);
	}
	else
	{
		CDialog::OnCancel();
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUSB8VI4DI0RDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSB8VI4DI0RDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSB8VI4DI0RDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
////////////////////////////////////////////////////////////////////////
// Contols
////////////////////////////////////////////////////////////////////////
bool CUSB8VI4DI0RDlg::SetUpComPort(void)
{
	int PortNum;
	CString dummyString;
    char buffer [10];

	int nResponse = selectdlg.DoModal();

	if (nResponse == IDOK)
	{
		//  Code here to handle when the dialog is
		//  dismissed with OK
		PortNum = selectdlg.PortValue();
		sprintf(buffer,"Com%d", PortNum);

		return SelectCommPort(PortNum);
	}
	return false;
}

void CUSB8VI4DI0RDlg::SetUpControls(void)
{
	////////////////////////////////////////////////////////////////////
	// Initialise scroll bars
	m_vsbCycleInterval.SetScrollRange(10,1000,TRUE);
	m_vsbCycleInterval.SetScrollPos(500, FALSE);

	m_vsbPortInterval.SetScrollRange(10,1000,TRUE);
	m_vsbPortInterval.SetScrollPos(500, FALSE);

	mVScrollPos = 500;
	mHScrollPos = 500;

	m_txtIntVal = mVScrollPos;
    m_Port_Interval = mHScrollPos;
}

void CUSB8VI4DI0RDlg::EnableControls()
{
	// 
    mRelayOpen.EnableWindow(true);
    mRelayClose.EnableWindow(true);
    mRelayClear.EnableWindow(true);
    mRelayCycStart.EnableWindow(true);
	mSelectPortScan.EnableWindow(true);
	m_txtRelayCycle.ShowWindow(1);
	m_txtRelayCycle.SetWindowText("Recycling Off");
    Initialise();
}

void CUSB8VI4DI0RDlg::DisableControls()
{

    mRelayOpen.EnableWindow(false);
    mRelayClose.EnableWindow(false);
    mRelayClear.EnableWindow(false);
    mRelayCycStart.EnableWindow(false);
	mSelectPortScan.EnableWindow(false);
}

void CUSB8VI4DI0RDlg::Initialise()
{
    
    // set Controls
    mRelayRecycleOff.SetCheck( true);
    mRelayRecycleOn.SetCheck(false);
    mRelaysCycling = false;
	mRelayRecycleOn.SetCheck(FALSE);
	mRelayRecycleOff.SetCheck(TRUE);
	mbRecycleOn = false;
    mbCloseRelays = true;
	m_txtRelayCycle.SetWindowText("Closing Relay:");
	// Set flags to indcate start of cycle
    mbScanComplete = false;

    // Set all PIC ports to Outputs
    ControlInterface->SetPortStates ('B',InputState, 0xFF);
    ControlInterface->SetPortStates ('C',OutputState,0xFF);
	// The upper 4 pins of port C are inputs
    ControlInterface->SetPortStates ('C',InputState, 0xF0);

    m_Port_Reading = "";
	// Set text boxes
	muRelayPos = 0;

	m_Relay_Num = muRelayPos;
	UpdateData(FALSE);
}
// Selects the communication port and sets menu checks
bool CUSB8VI4DI0RDlg::SelectCommPort(int portnum)
{
    char buffer[10];

	m_pmnuPort->CheckMenuItem(0,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(1,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(2,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(3,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(4,MF_UNCHECKED | MF_BYPOSITION);
    
	m_pmnuPort->CheckMenuItem(portnum - 1,MF_CHECKED | MF_BYPOSITION);


	CString sPortName;

	switch(portnum)
	{
		case 1 : sPortName = "Com1"; break;
		case 2 : sPortName = "Com2"; break;
		case 3 : sPortName = "Com3"; break;
		case 4 : sPortName = "Com4"; break;
		case 5 : sPortName = "Com5"; break;
		default :
			sprintf(buffer,"Com%d",portnum);
			sPortName = buffer;
			break;
	}

    if (ControlInterface->SetComPortNum(portnum) == TRUE )
    {
        mPort = portnum;
	    ControlInterface->CreateCommPort(mPort);
        m_txtCommPort = mPort;
        EnableControls();
		Initialise();
		UpdateData(FALSE);
        return true;
    } 
    else
    {
        mPort = 0;
        m_txtCommPort = mPort;
		UpdateData(FALSE);
        DisableControls();
        MessageBox ("Invalid Comm Port", "COMM PORT", MB_OK | MB_ICONEXCLAMATION);
		return false;
    }


}

////////////////////////////////////////////////////////////////////////
// Control Handling
////////////////////////////////////////////////////////////////////////
void CUSB8VI4DI0RDlg::OnStart() 
{
	if ( mRelaysCycling == false )
    {
        // Set other controls off
		mRelayClear.EnableWindow( false);
        mRelayClose.EnableWindow( false);
        mRelayOpen.EnableWindow ( false);
		// Change button caption to Stop
        mRelayCycStart.SetWindowText("Stop");
		// Change label to indicate now closing relays
        mbCloseRelays = true;
		//m_txtRelayCycle.SetWindowText("Closing Relay:");
		// Set flags to indcate start of cycle
        mbScanComplete = false;
		mRelaysCycling = true;

		// Start Timer
        SetTimer(RELAY_INTERVAL_TIMER,mVScrollPos ,NULL);
    }
    else
    {
        // Button now clicked to stop cycling
		// Stop timer
		KillTimer(RELAY_INTERVAL_TIMER);
        
		// Set other controls to Active
		mRelayClear.EnableWindow(true);
        mRelayClose.EnableWindow(true);
        mRelayOpen.EnableWindow (true);
		// Set label to indicate relays not cycling
        m_txtRelayCycle.SetWindowText("Cycling Off:");
		// Change button caption to Start
        mRelayCycStart.SetWindowText("Start");
		// Change button toggle
		mRelaysCycling = false;
    }
}

void CUSB8VI4DI0RDlg::OnClose() 
{
    int iRelayNum;
    int iRelay;
	CString sRelValue;

	m_edRelayNum.GetWindowText(sRelValue);

	iRelayNum = atoi(sRelValue);

    if (CalculateRelay(iRelayNum, &iRelay) == true)
    {
                
        ControlInterface->CloseRelay (iRelayNum,1);
    }
    else
    {
        MessageBox ("Value out of range", "Relay Number", MB_OK);
    }
}

void CUSB8VI4DI0RDlg::OnOpen() 
{
    int iRelayNum;
    int iRelay;
    int iBank;
	CString sRelValue;

	iBank = 1;

	m_edRelayNum.GetWindowText(sRelValue);

	iRelayNum = atoi(sRelValue);
    
    if (CalculateRelay(iRelayNum, &iRelay) == true)
    {
       ControlInterface->OpenRelay (iRelayNum, iBank);
    }
    else
    {
        MessageBox ("Value out of range", "Relay Number", MB_OK);
    } 
}

void CUSB8VI4DI0RDlg::OnClear() 
{
    ControlInterface->ClearRelays(GIMAXRELAY);

	// Set text boxes
    m_Relay_Num = 0;
	muRelayPos = 0;
	m_Relay_Num = 0;
	UpdateData(FALSE);
	
}

void CUSB8VI4DI0RDlg::OnPortScanButton() 
{
	CString ScanText;
    m_Port_Reading = "";
	mSelectPortScan.GetWindowText (ScanText); 
	if ( ScanText == "StartScan")
	{
		mSelectPortScan.SetWindowText("StopScan");
		SetTimer (SCAN_INTERVAL_TIMER, 500,NULL );
	}
	else
	{
		mSelectPortScan.SetWindowText("StartScan");
		KillTimer (SCAN_INTERVAL_TIMER);
	}
}

void CUSB8VI4DI0RDlg::OnRecycleOn() 
{
    mbRecycleOn = true;

	if ( mRelayRecycleOff.GetCheck() == TRUE )
	{
		mRelayRecycleOff.SetCheck(FALSE);
	}
	else
	{
		mRelayRecycleOn.SetCheck(TRUE);
	}
}

void CUSB8VI4DI0RDlg::OnRecycleOff() 
{
    mbRecycleOn = false;

	if ( mRelayRecycleOn.GetCheck() == TRUE )
	{
		mRelayRecycleOn.SetCheck(FALSE);
	}
	else
	{
		mRelayRecycleOff.SetCheck(TRUE);
	}
}

void CUSB8VI4DI0RDlg::OnCommportPort1() 
{
	mPort = 1;
	SelectCommPort(mPort);
}

void CUSB8VI4DI0RDlg::OnCommportPort2() 
{
	mPort = 2;
	SelectCommPort(mPort);
}

void CUSB8VI4DI0RDlg::OnCommportPort3() 
{
	mPort = 3;
	SelectCommPort(mPort);
}

void CUSB8VI4DI0RDlg::OnCommportPort4() 
{
	mPort = 4;
	SelectCommPort(mPort);
}

void CUSB8VI4DI0RDlg::OnCommportSelectport() 
{
	int nResponse = selectdlg.DoModal();
	if (nResponse == IDOK)
	{
		//  Code here to handle when the dialog is
		//  dismissed with OK
		mPort = selectdlg.PortValue();

    	SelectCommPort(mPort);
	}
	else if (nResponse == IDCANCEL)
	{

	}	
}

void CUSB8VI4DI0RDlg::OnDataportPortb() 
{
	// Select port Access for port C
	m_DataPortSelected = "B";
	m_pmnuData->CheckMenuItem (0,MF_CHECKED | MF_BYPOSITION);
	m_pmnuData->CheckMenuItem (1,MF_UNCHECKED | MF_BYPOSITION);
	m_Port_Reading = "";
	UpdateData(FALSE);
}

void CUSB8VI4DI0RDlg::OnDataportPortc() 
{
	// Select port Access for port C
	m_DataPortSelected = "C";
	m_pmnuData->CheckMenuItem (0,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuData->CheckMenuItem (1,MF_CHECKED | MF_BYPOSITION);
	m_Port_Reading = "";
	UpdateData(FALSE);
}

void CUSB8VI4DI0RDlg::OnFileExit() 
{
   //Check if ( port is open before trying to clear
   if ( mPort != 0 )
   {
      ControlInterface->ClearRelays(GIMAXRELAY);
   }
    
   //Form.close;
	CDialog::OnCancel();
}


// This function called every time timer expirers
// Calls the Scan relays function that will step
// through and close/open each relay in turn
void CUSB8VI4DI0RDlg::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{
		case RELAY_INTERVAL_TIMER:

			Scan_Relays();
    
		break;

		case SCAN_INTERVAL_TIMER:

			ScanInputPort();

		break;

		case READ_INTERVAL_TIMER:
			port->TerminateOutstandingReads();
	}
	UpdateData(FALSE);
	
	CDialog::OnTimer(nIDEvent);
}

////////////////////////////////////////////////////////////////////////
// Controls the Verical Scroll Bar movements
void CUSB8VI4DI0RDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	mVScrollPos = m_vsbCycleInterval.GetScrollPos();

	switch (nSBCode)
	{
	case SB_BOTTOM:      // Scroll to far left.
		mVScrollPos = 0;
		break;

	case SB_TOP:      // Scroll to far right.
		mVScrollPos = 1000;
		break;

	case SB_ENDSCROLL:   // End scroll.
		break;

	case SB_LINEDOWN:      // Scroll down.
		if (mVScrollPos < 1000)
			mVScrollPos+= 10;
		break;

	case SB_LINEUP:   // Scroll up.
		if (mVScrollPos > 10)
			mVScrollPos-= 10;
		break;

	case SB_PAGEUP:    // Scroll one page up.
		{
			if (mVScrollPos > 0)
				mVScrollPos = max(0, mVScrollPos - 100);

		}
		break;

	case SB_PAGEDOWN:      // Scroll one page down
		{
			if (mVScrollPos < 1000)
				mVScrollPos = min(1000, mVScrollPos + 100);
		}
		break;

	case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
		mVScrollPos = (nPos/10) * 10;      // of the scroll box at the end of the drag operation.
		break;

	case SB_THUMBTRACK:      // Drag scroll box to specified position. nPos is the
		mVScrollPos = (nPos/10) * 10; // position that the scroll box has been dragged to.
		break;
	}

	// Set the new position of the thumb (scroll box).
	m_vsbCycleInterval.SetScrollPos(mVScrollPos, TRUE);

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);

	m_txtIntVal = mVScrollPos;
	UpdateData(FALSE);

}

//Controls Horizontal scroll bar
void CUSB8VI4DI0RDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	mHScrollPos = m_vsbPortInterval.GetScrollPos();

	switch (nSBCode)
	{
	case SB_BOTTOM:      // Scroll to far left.
		mHScrollPos = 0;
		break;

	case SB_TOP:      // Scroll to far right.
		mHScrollPos = 1000;
		break;

	case SB_ENDSCROLL:   // End scroll.
		break;

	case SB_LINERIGHT:      // Scroll left.
		if (mHScrollPos < 1000)
			mHScrollPos+= 10;
		break;

	case SB_LINELEFT:    // Scroll right.
		if (mHScrollPos > 10)
			mHScrollPos-= 10;
		break;

	case SB_PAGELEFT:    // Scroll one page up.
		{
			if (mHScrollPos > 0)
				mHScrollPos = max(0, mHScrollPos - 100);

		}
		break;

	case SB_PAGERIGHT:   // Scroll one page down
		{
			if (mHScrollPos < 1000)
				mHScrollPos = min(1000, mHScrollPos + 100);
		}
		break;

	case SB_THUMBPOSITION:  // Scroll to absolute position. nPos is the position
		mHScrollPos = (nPos/10) * 10; // of the scroll box at the end of the drag operation.
		break;

	case SB_THUMBTRACK:     // Drag scroll box to specified position. nPos is the
		mHScrollPos = (nPos/10) * 10; // position that the scroll box has been dragged to.
		break;
	}

	// Set the new position of the thumb (scroll box).
	m_vsbPortInterval.SetScrollPos(mHScrollPos, TRUE);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

	m_Port_Interval = mHScrollPos;
	UpdateData(FALSE);

	
}

void CUSB8VI4DI0RDlg::OnHelpAbout() 
{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
}

void CUSB8VI4DI0RDlg::OnHelpDevicemanager() 
{
		int response = system("C://WINDOWS//system32//mmc.exe C://WINDOWS//system32//devmgmt.msc //s");	
}
////////////////////////////////////////////////////////////////////////
// Relay control functions
////////////////////////////////////////////////////////////////////////

// Used by OnOpen/OnClose to convert a relay number to the
// appropriate relay and bank values.
bool CUSB8VI4DI0RDlg::CalculateRelay(int iRelayNum, int * RelayPos)
{

    if ( iRelayNum > 0 && iRelayNum <= GIMAXRELAY )
    {
        //Calculate Relay
        *RelayPos = iRelayNum % GIMAXRELAY;

        if ( *RelayPos == 0 )
        {
            *RelayPos = GIMAXRELAY;
        }
        
		return true;
	}
	else
	{
		return false;
	}

}

// This function is called each time the timer expires
// It will increment the relay to be open /closed and
// when all relays are accessed, will open each relay.
void CUSB8VI4DI0RDlg::Scan_Relays(void)
{
    if( mbCloseRelays == true)
	{
        //Closing Relays
        muRelayPos++;
        if (muRelayPos <= GIMAXRELAY)
		{
            ControlInterface->CloseRelay (muRelayPos,1);
            m_txtRelayCycle.SetWindowText("Closing Relay:");
		}
		else
		{
            //Reached maximum so now open highest number relay
            mbCloseRelays = false;
            muRelayPos--;
            ControlInterface->OpenRelay (muRelayPos,1);
            m_txtRelayCycle.SetWindowText("Opening Relay:");
		}
	}
    else
	{
        //Opening Relays
        muRelayPos = muRelayPos - 1;
        if (muRelayPos >= 0)
		{
            ControlInterface->OpenRelay (muRelayPos,1);
            m_txtRelayCycle.SetWindowText("Opening Relay:");
		}
        else
		{
            //Reached the end of opening relays cycle
            muRelayPos++;
			mbScanComplete = true;
        }
    }  

	if ( mbScanComplete == true )
	{
		if ( mbRecycleOn == false )
		{
			KillTimer(RELAY_INTERVAL_TIMER);
			mRelayCycStart.SetWindowText("Start");
			mRelaysCycling = false;
			m_txtRelayCycle.SetWindowText("Cycling Off");

			mRelayClear.EnableWindow(true);
			mRelayOpen.EnableWindow(true);
			mRelayClose.EnableWindow(true);
		}
		else
		{
			mbScanComplete = false;
			mbCloseRelays = true;
		}
	}

	m_Relay_Num = muRelayPos;
	UpdateData(FALSE);
}

void CUSB8VI4DI0RDlg::ScanInputPort(void)
{
	unsigned char PortValue;
	unsigned char CPortValue;

	char Buffer[10];

	if (port->IsOpen())
	{
		if (m_DataPortSelected == "B")
		{
			PortValue = ControlInterface->ReadDataPortVal ('B');
		}
		else
		{
			CPortValue = ControlInterface->ReadDataPortVal ('C');
			// Correct value as reading top 4 pins 
			PortValue = ((CPortValue & 0xF0) >> 4);
		}
		sprintf (Buffer, "0x%X", PortValue);
		m_Port_Reading = (Buffer);
		UpdateData(FALSE);
	}
}


