///////////////////////////////////////////////////////////////////////
// USB8VI4DI0RDlg.h : header file
// Author : Philip Allen
// Version :1   Date   : 2  September 2007 Initial Version
// Version :2   Date   : 16 November  2007 Changes to match new Module Interface
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_USB8VI4DI0RDLG_H__396507B1_61B8_4B9C_B724_0D1BB2BF7A04__INCLUDED_)
#define AFX_USB8VI4DI0RDLG_H__396507B1_61B8_4B9C_B724_0D1BB2BF7A04__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CUSB8VI4DI0RDlg dialog
#define RELAY_INTERVAL_TIMER 1001
#define SCAN_INTERVAL_TIMER  2001
#define READ_INTERVAL_TIMER  3001

#define GIMAXRELAY 4
#define GIMAXBANK  1


class CUSB8VI4DI0RDlg : public CDialog
{
// Construction
public:
	CUSB8VI4DI0RDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CUSB8VI4DI0RDlg)
	enum { IDD = IDD_USB8VI4DI0R_DIALOG };
	CButton	mRelayRecycleOff;
	CButton	mRelayRecycleOn;
	CButton	mRelayCycStart;
	CButton	mRelayOpen;
	CButton	mRelayClose;
	CButton	mRelayClear;
	CButton	mSelectPortScan;
	CSliderCtrl	m_sliderRelayInterval;
	CSliderCtrl	m_sliderPortSampleInterval;
	CStatic	m_txtRelayCycle;
	CEdit	m_edRelayNum;
	CScrollBar	m_vsbPortInterval;
	CScrollBar	m_vsbCycleInterval;
	int		m_txtIntVal;
	int		m_Port_Interval;
	int		m_Port_Number;
	int		m_Relay_Num;
	int		m_txtCommPort;
	CString	m_DataPortSelected;
	CString	m_Port_Reading;
	//}}AFX_DATA

	CMenu * m_mainMenu;		// Main Menu handle
	CMenu * m_pmnuPort;		// Comm port select menu handle
	CMenu * m_pmnuData;		// Data port select menu handle

	int  mPort;
	int  mVScrollPos;
	int  mHScrollPos;
	bool mbScanComplete;
	bool mbRecycleOn;
	bool mbRecycleOff;
	bool mRelaysCycling;
	bool mbCloseRelays;
	int  muRelayPos;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUSB8VI4DI0RDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CUSB8VI4DI0RDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRecycleOn();
	afx_msg void OnRecycleOff();
	afx_msg void OnStart();
	afx_msg void OnClose();
	afx_msg void OnOpen();
	afx_msg void OnClear();
	afx_msg void OnCommportPort1();
	afx_msg void OnCommportPort2();
	afx_msg void OnCommportPort3();
	afx_msg void OnCommportPort4();
	afx_msg void OnCommportSelectport();
	afx_msg void OnDataportPortb();
	afx_msg void OnDataportPortc();
	afx_msg void OnFileExit();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnPortScanButton();
	afx_msg void OnHelpAbout();
	afx_msg void OnHelpDevicemanager();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void SetUpControls(void);
	void EnableControls();
	void DisableControls();
	void Initialise();
	void Scan_Relays(void);
	bool SelectCommPort(int portnum);
	bool CalculateRelay(int iRelayNum, int * RelayPos);
	void ScanInputPort(void);
	bool SetUpComPort(void);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_USB8VI4DI0RDLG_H__396507B1_61B8_4B9C_B724_0D1BB2BF7A04__INCLUDED_)
